// ==================================================
// Fonction d'affichage des resultats des algorithmes
// ==================================================

function [numwin] = affiche(numwin,legende,xtot,ytot,alpha)

//
// Affichage graphique
// -------------------
//

   if 0 == exists('numwin') then
      numwin = 0; 
   end
   numwin = numwin+1;
   xset("window",numwin);
   xbasc(numwin);
   xset("font size",3);
   xset("thickness",2);
   plot2d(xtot',ytot');
   xtitle(legende);
   xselect();

//
// Coupure des premieres iterations, ordonnee maximale et legende
//

   ok = %t;
   while ok == %t then
      if 1 == exists('icoup') then
         [ok,icoup,ymax,titok] = getvalue("Affinage du graphique",...
             ["iteration de coupure";"ordonnee maximale";"legende"],...
             list("vec",1,"vec",1,"vec",1),...
             [string(icoup);string(ymax);string(titok)]);
      else
         [ok,icoup,ymax,titok] = getvalue("Affinage du graphique",...
             ["iteration de coupure";"ordonnee maximale";"legende"],...
             list("vec",1,"vec",1,"vec",1),...
             [string(0);string(1);string(0)]);
      end

      if ok == %t then
         numwin = numwin+1;
         xset("window",numwin);
         xbasc(numwin);
         xset("font size",3);
         xset("thickness",2);
         if ymax > 0 then
            plot2d(xtot(:,icoup+1:$)',ytot(:,icoup+1:$)',rect=[0,0,n,ymax]);
            legends('a='+string(alpha),style=0,[0.8*n;ymax],%f);
         else
            plot2d(xtot(:,icoup+1:$)',ytot(:,icoup+1:$)');
         end
         if titok == 1 then
            if icoup > 0 then
               xtitle([legende ;...
                       '---> depuis la '+string(icoup+1)+'-ieme iteration']);
            else
               xtitle([legende]);
            end
         end
       else 
        break;
      end
   end

endfunction

/////////////////////////////
// S.O.W.G - Decembre 2007 //
/////////////////////////////
