// ===================================================================
// Programme de simulation unique pour le gradient stochastique normal
// ===================================================================

   XnNORM = [];
   XoNORM = [];

//
// Condition initiale
// ------------------
//

   Xd = 10;
   X0 = Xd*(grand(dim,1,'def')-0.5*ones(dim,1));

//
// Gradient stochastique et estimation par Monte-Carlo
// ---------------------------------------------------
//

   Xn = X0;
   Xo = zeros(dim);

   for k = 1:n

//
//    Tirage aleatoire
//

      VA = q*grand(dim,1,'nor',0,1);
      MA = zeros(dim,dim);

//      Cas d'une matrice aleatoire dans le critere
//
//      MA = grand(dim,'mn',Mea,Cov);

//
//    Pas de gradient stochastique
//

      Xn = Xn-(alfan/(thetan+k^lamdan))*((B+MA)*Xn+VA);

//
//    Estimateur optimal par Monte-Carlo
//

      Xo = (((k-1)*Xo)-(C*VA)) / k;

//
//    Normes des iterees
//

      XnNORM = [XnNORM,norm(Xn)];
      XoNORM = [XoNORM,norm(Xo)];

   end

//
// Constitution du graphique
// -------------------------
//

   legende = string(nbsimul)+' simulation(s) '+...
             'de gradient stochastique normal : '+...
             string(alfan)+' / ('+string(thetan)+'+k^'+string(lamdan)+')';
   legende = [legende ;...
              '- noir : norme des iterees du gradient stochastique' ; ...
              '- bleu : norme des iterees de Monte-Carlo optimal'];

//
// Matrice des abscisses
//

   xtot = [1:n ; 1:n ; 1:n];

//
// Matrice des ordonnees (avec reference a zero)
//

   ytot = [XnNORM ; XoNORM ; zeros(1:n)];

//
// Valeurs finales
//

   vf = ytot(1:2,n);

//
// Affichage graphique
// -------------------
//

   numwin = affiche(numwin,legende,xtot,ytot,alfan);

//
// Valeurs finales
//

   x_message(['Valeurs finales';' ';...
              '- gradient stochastique normal      : '+string(vf(1));...
              '- estimateur optimal de Monte-Carlo : '+string(vf(2))])

/////////////////////////////
// S.O.W.G - Decembre 2007 //
/////////////////////////////
