// ====================================================================
// Programme de simulation unique pour le gradient stochastique moyenne
// ====================================================================

   XkNORM = [];
   XmNORM = [];
   XoNORM = [];

//
// Condition initiale
// ------------------
//

   Xd = 10;
   X0 = Xd*(grand(dim,1,'def')-0.5*ones(dim,1));

//
// Gradient stochastique et estimation par Monte-Carlo
// ---------------------------------------------------
//

   Xk = X0;
   Xm = X0;
   Xo = zeros(dim);

   for k = 1:n

//
//    Tirage aleatoire
//

      VA = q*grand(dim,1,'nor',0,1);
      MA = zeros(dim,dim);

//      Cas d'une matrice aleatoire dans le critere
//
//      MA = grand(dim,'mn',Mea,Cov);

//
//    Pas de gradient stochastique
//

      Xk = Xk-(alfam/(thetam+k^lamdam))*((B+MA)*Xk+VA);

//
//    Moyennisation des iterees
//

      if k <= nsm
         Xm = Xk;
      else
         Xm = (((k-nsm-1)*Xm)+Xk) / (k-nsm);
      end

//
//    Estimateur optimal par Monte-Carlo
//

      Xo = (((k-1)*Xo)-(C*VA)) / k;

//
//    Normes des iterees
//

      XkNORM = [XkNORM,norm(Xk)];
      XmNORM = [XmNORM,norm(Xm)];
      XoNORM = [XoNORM,norm(Xo)];

   end

//
// Constitution du graphique
// -------------------------
//

   legende = string(nbsimul)+' simulation(s) '+...
             'de gradient stochastique moyenne : '+...
             string(alfam)+' / ('+string(thetam)+'+k^'+string(lamdam)+')';
   legende = [legende ;...
              '- noir : norme des iterees avant moyennisation' ; ...
              '- vert : norme des iterees apres moyennisation' ; ...
              '- bleu : norme des iterees de Monte-Carlo optimal'];

//
// Matrice des abscisses
//

   xtot = [1:n ; 1:n ; 1:n ; 1:n];

//
// Matrice des ordonnees (avec reference a zero)
//

   ytot = [XkNORM ; XoNORM ; XmNORM ; zeros(1:n)];

//
// Valeurs finales
//

   vf = ytot(1:3,n);

//
// Affichage graphique
// -------------------
//

   numwin = affiche(numwin,legende,xtot,ytot,alfam);

//
// Valeurs finales
//

   x_message(['Valeurs finales';' ';...
              '- gradient stochastique avant moyenne : '+string(vf(1));...
              '- gradient stochastique apres moyenne : '+string(vf(3));...
              '- estimateur optimal de Monte-Carlo   : '+string(vf(2))])

/////////////////////////////
// S.O.W.G - Decembre 2007 //
/////////////////////////////
