// ====================================================================
// Programme de simulation unique pour les deux gradients stochastiques
// ====================================================================

   XnNORM = [];
   XkNORM = [];
   XmNORM = [];
   XoNORM = [];

//
// Condition initiale
// ------------------
//

   Xd = 10;
   X0 = Xd*(grand(dim,1,'def')-0.5*ones(dim,1));

//
// Gradients stochastiques et estimation par Monte-Carlo
// -----------------------------------------------------
//

   Xn = X0;
   Xk = X0;
   Xm = X0;
   Xo = zeros(dim);

   for k = 1:n

//
//    Tirage aleatoire
//

      VA = q*grand(dim,1,'nor',0,1);
      MA = zeros(dim,dim);

//      Cas d'une matrice aleatoire dans le critere
//
//      MA = grand(dim,'mn',Mea,Cov);

//
//    Pas de gradient stochastique normal
//

      Xn = Xn-(alfan/(thetan+k^lamdan))*((B+MA)*Xn+VA);

//
//    Pas de gradient stochastique moyenne
//

      Xk = Xk-(alfam/(thetam+k^lamdam))*((B+MA)*Xk+VA);
      if k <= nsm
         Xm = Xk;
      else
         Xm = (((k-nsm-1)*Xm)+Xk) / (k-nsm);
      end

//
//    Estimateur optimal par Monte-Carlo
//

      Xo = (((k-1)*Xo)-(C*VA)) / k;

//
//    Normes des iterees
//

      XnNORM = [XnNORM,norm(Xn)];
      XkNORM = [XkNORM,norm(Xk)];
      XmNORM = [XmNORM,norm(Xm)];
      XoNORM = [XoNORM,norm(Xo)];

   end

//
// Constitution du graphique
// -------------------------
//

   legende = string(nbsimul)+' simulation(s) '+...
             'de gradient stochastique normal : '+...
              string(alfan)+' / ('+string(thetan)+'+k^'+string(lamdan)+') '+...
              'et moyenne : '+...
              string(alfam)+' / ('+string(thetam)+'+k^'+string(lamdam)+')';
   legende = [legende ;...
              '- noir : norme des iterees du gradient stochastique normal' ;...
              '- vert : norme des iterees du gradient stochastique moyenne';...
              '- bleu : norme des iterees de Monte-Carlo optimal'];

//
// Matrice des abscisses
//

   xtot = [1:n ; 1:n ; 1:n ; 1:n];

//
// Matrice des ordonnees (avec reference a zero)
//

   ytot = [XnNORM ; XoNORM ; XmNORM ; zeros(1:n)];

//
// Valeurs finales
//

   vf = ytot(1:3,n);

//
// Affichage graphique
// -------------------
//

   numwin = affiche(numwin,legende,xtot,ytot,alfan);

//
// Valeurs finales
//

   x_message(['Valeurs finales';' ';...
              '- gradient stochastique normal      : '+string(vf(1));...
              '- gradient stochastique moyenne     : '+string(vf(3));...
              '- estimateur optimal de Monte-Carlo : '+string(vf(2))])

/////////////////////////////
// S.O.W.G - Decembre 2007 //
/////////////////////////////
