// ======================================================================
// Programme de simulation multiple pour le gradient stochastique moyenne
// ======================================================================

   XmNORM = zeros(2,n);
   XoNORM = zeros(2,n);

//
// Condition initiale
// ------------------
//

   Xd = 10;
   X0 = Xd*(grand(dim,1,'def')-0.5*ones(dim,1));

//
// Boucle sur les simulations des algorithmes
// ------------------------------------------
//

   for ns = 1:nbsimul

//
//    Algorithmes de gradient stochastique et de Monte-Carlo
//

      Xk = X0;
      Xm = X0;
      Xo = zeros(dim);

      for k = 1:n

//
//       Tirage aleatoire
//

         VA = q*grand(dim,1,'nor',0,1);
         MA = zeros(dim,dim);

//         Cas d'une matrice aleatoire dans le critere
//
//         MA = grand(dim,'mn',Mea,Cov);

//
//       Pas de gradient stochastique
//

         Xk = Xk-(alfam/(thetam+k^lamdam))*((B+MA)*Xk+VA);

//
//       Moyennisation des iterees
//

         if k <= nsm
            Xm = Xk;
         else
            Xm = (((k-nsm-1)*Xm)+Xk) / (k-nsm);
         end

//
//       Estimateur optimal par Monte-Carlo
//

         Xo = (((k-1)*Xo)-(C*VA)) / k;

//
//       Norme des moyennes (sur les simulations) apres moyennisation
//

         XmNORM(1,k) = (((ns-1)*XmNORM(1,k))+norm(Xm)) / ns;
         XmNORM(2,k) = (((ns-1)*XmNORM(2,k))+(norm(Xm)^2)) / ns;

//
//       Norme des moyennes (sur les simulations) des estimateurs
//

         XoNORM(1,k) = (((ns-1)*XoNORM(1,k))+norm(Xo)) / ns;
         XoNORM(2,k) = (((ns-1)*XoNORM(2,k))+(norm(Xo)^2)) / ns;

      end

   end

//
// Constitution du graphique
// -------------------------
//

   legende = string(nbsimul)+' simulation(s) '+...
             'de gradient stochastique moyenne : '+...
             string(alfam)+' / ('+string(thetam)+'+k^'+string(lamdam)+')';
   legende = [legende ;...
              '- noir-bleu : moyenne +/- ecart-type de la norme '+...
              'des iterees apres moyennisation' ;...
              '- vert-ciel : moyenne +/- ecart-type de la norme '+...
              'des iterees de Monte-Carlo optimal'];

//
// Matrice des abscisses
//

   xtot = [1:n ; 1:n ; 1:n ; 1:n ; 1:n];

//
// Matrice des ordonnees
//

   ytot = [];
   for k = 1:n

//
//    Intervalle de confiance sur les iterees apres moyennisation
//

      ect = sqrt((nbsimul/(nbsimul-1))*(XmNORM(2,k)-(XmNORM(1,k)^2)));
      ytot([1:2],k) = [XmNORM(1,k)-ect ; XmNORM(1,k)+ect];

//
//    Intervalle de confiance sur les iterees de l'estimateur optimal
//

      ect = sqrt((nbsimul/(nbsimul-1))*(XoNORM(2,k)-(XoNORM(1,k)^2)));
      ytot([3:4],k) = [XoNORM(1,k)-ect ; XoNORM(1,k)+ect];

//
//    Reference a zero
//

      ytot(5,k) = 0;

   end

//
// Valeurs finales
//

   vf = ytot(1:4,n);

//
// Affichage graphique
// -------------------
//

   numwin = affiche(numwin,legende,xtot,ytot,alfam);

//
// Valeurs finales
//

   x_message(['Valeurs finales';' ';...
              '- gradient stochastique moyenne     : '+string(vf(1:2));...
              '- estimateur optimal de Monte-Carlo : '+string(vf(3:4))])

/////////////////////////////
// S.O.W.G - Decembre 2007 //
/////////////////////////////
