// ======================================================================
// Programme de simulation multiple pour les deux gradients stochastiques
// ======================================================================

   XnNORM = zeros(2,n);
   XmNORM = zeros(2,n);
   XoNORM = zeros(2,n);

//
// Condition initiale
// ------------------
//

   Xd = 10;
   X0 = Xd*(grand(dim,1,'def')-0.5*ones(dim,1));

//
// Boucle sur les simulations des algorithmes
// ------------------------------------------
//

   for ns = 1:nbsimul

//
//    Algorithmes de gradient stochastique et de Monte-Carlo
//

      Xn = X0;
      Xk = X0;
      Xm = X0;
      Xo = zeros(dim);

      for k = 1:n

//
//       Tirage aleatoire
//

         VA = q*grand(dim,1,'nor',0,1);
         MA = zeros(dim,dim);

//         Cas d'une matrice aleatoire dans le critere
//
//        MA = grand(dim,'mn',Mea,Cov);

//
//       Pas de gradient stochastique normal
//

         Xn = Xn-(alfan/(thetan+k^lamdan))*((B+MA)*Xn+VA);

//
//       Pas de gradient stochastique moyenne
//

         Xk = Xk-(alfam/(thetam+k^lamdam))*((B+MA)*Xk+VA);
         if k <= nsm
            Xm = Xk;
         else
            Xm = (((k-nsm-1)*Xm)+Xk) / (k-nsm);
         end

//
//       Estimateur optimal par Monte-Carlo
//

         Xo = (((k-1)*Xo)-(C*VA)) / k;

//
//       Norme des moyennes sur les simulations
//

         XnNORM(1,k) = (((ns-1)*XnNORM(1,k))+norm(Xn)) / ns;
         XnNORM(2,k) = (((ns-1)*XnNORM(2,k))+(norm(Xn)^2)) / ns;

         XmNORM(1,k) = (((ns-1)*XmNORM(1,k))+norm(Xm)) / ns;
         XmNORM(2,k) = (((ns-1)*XmNORM(2,k))+(norm(Xm)^2)) / ns;

         XoNORM(1,k) = (((ns-1)*XoNORM(1,k))+norm(Xo)) / ns;
         XoNORM(2,k) = (((ns-1)*XoNORM(2,k))+(norm(Xo)^2)) / ns;

      end

   end

//
// Constitution du graphique
// -------------------------
//

   legende = string(nbsimul)+' simulation(s) '+...
             'de gradient stochastique normal : '+...
              string(alfan)+' / ('+string(thetan)+'+k^'+string(lamdan)+') '+...
              'et moyenne : '+...
              string(alfam)+' / ('+string(thetam)+'+k^'+string(lamdam)+')';
   legende = [legende ;...
              '- noir-bleu   : moyenne +/- ecart-type de la norme '+...
              'des iterees du gradient normal' ;...
              '- vert-ciel   : moyenne +/- ecart-type de la norme '+...
              'des iterees du gradient moyenne' ;...
              '- rouge-mauve : moyenne +/- ecart-type de la norme '+...
              'des iterees de Monte-Carlo optimal'];

//
// Matrice des abscisses
//

   xtot = [1:n ; 1:n ; 1:n ; 1:n ; 1:n ; 1:n ; 1:n];

//
// Matrice des ordonnees
//

   ytot = [];
   for k = 1:n

//
//    Intervalle de confiance sur les normes des moyennes
//

      ect = sqrt((nbsimul/(nbsimul-1))*(XnNORM(2,k)-(XnNORM(1,k)^2)));
      ytot([1:2],k) = [XnNORM(1,k)-ect ; XnNORM(1,k)+ect];

      ect = sqrt((nbsimul/(nbsimul-1))*(XmNORM(2,k)-(XmNORM(1,k)^2)));
      ytot([3:4],k) = [XmNORM(1,k)-ect ; XmNORM(1,k)+ect];

      ect = sqrt((nbsimul/(nbsimul-1))*(XoNORM(2,k)-(XoNORM(1,k)^2)));
      ytot([5:6],k) = [XoNORM(1,k)-ect ; XoNORM(1,k)+ect];

//
//    Reference a zero
//

      ytot(7,k) = 0;

   end

//
// Valeurs finales
//

   vf = ytot(1:6,n);

//
// Affichage graphique
// -------------------
//

   numwin = affiche(numwin,legende,xtot,ytot,alfan);

//
// Valeurs finales
//

   x_message(['Valeurs finales';' ';...
              '- gradient stochastique normal      : '+string(vf(1:2));...
              '- gradient stochastique moyenne     : '+string(vf(3:4));...
              '- estimateur optimal de Monte-Carlo : '+string(vf(5:6))])

/////////////////////////////
// S.O.W.G - Decembre 2007 //
/////////////////////////////
