// =================================================================
// Evaluation de la covariance pour les deux gradients stochastiques
// =================================================================

//
// Evolution des matrices de covariance des gradients stochastiques
//

   S = Cramer;
   BigS =[ Cramer,ZERO ; ZERO,Cramer];
   for k=1:n
      epsn = alfan/(thetan+k^lamdan);
      S = (I-epsn*B)*S*(I-epsn*B)+(epsn^2)*Q;
      epsm = alfam/(thetam+k^lamdam);
      BigQ = [Q,Q/k ; Q/k,Q/k^2];
      M = [I-epsm*B,zeros(B) ; (I-epsm*B)/k,I*((k-1)/k)];
      BigS = M*BigS*M'+(epsm^2)*BigQ;
   end
   S = n*S;
   T = n*BigS((dim+1):$,(dim+1):$);

//
// Comparaison avec la borne optimale
//

   disp('Valeurs propres extremes des matrices de covariance');
   Result = ['Borne de Cramer-Rao : ' ;...
             'Gradient normal     : ' ;...
             'Gradient moyenne    : '];
   Result=[Result,[string(Mmvp(Cramer)') ;...
                   string(Mmvp(S)') ;...
                   string(Mmvp(T)')]];
   disp(Result);

////////////////////////////
// S.O.W.G - Janvier 2004 //
////////////////////////////
