// ======================================================
// Lecture des parametres des deux algorithmes simultanes
// ======================================================
//
// On propose les valeurs existantes si ces parametres ont
// deja ete definis (coefficients des sigma-suites, nombre
// d'iterations), et des valeurs par defaut sinon.
//
// Forme des sigma-suites : alpha / (k^lambda + theta)

//
// Valeurs des parametres
//

   labels = ["alpha (normal)";"theta (normal)";...
             "alpha (moyenne)";"theta (moyenne)";"lambda (moyenne)";...
             "nbiter";"nstart"];
   if 1 == exists('alfan') then
      [ok,alfan,thetan,alfam,thetam,lamdam,n,nsm] = ...
          getvalue("reglage des gradients stochastiques",labels,...
          list("vec",1,"vec",1,"vec",1,"vec",1,"vec",1,"vec",1,"vec",1),...
          [string(alfan);string(thetan);...
           string(alfam);string(thetam);string(lamdam);...
           string(n);string(nsm)]);
   else
      [ok,alfan,thetan,alfam,thetam,lamdam,n,nsm] = ...
          getvalue("reglage des gradients stochastiques",labels,...
          list("vec",1,"vec",1,"vec",1,"vec",1,"vec",1,"vec",1,"vec",1),...
          [string(1);string(10);...
           string(1);string(10);string(0.66);...
           string(5000);string(100)]);
   end

//
// Exposant de l'indice d'iteration pour le gradient normal
//

   lamdan = 1;

//
// Affichage des valeurs retenues
//
   

   disp('Les deux gradients stochastiques ; '+...
        'pas en : alpha / (k^lambda + theta)');

   disp('- nombre des iterations');
   valeurs = [' nbiter = '+string(n)      ; ...
              ' nstart = '+string(nsm)];
   disp(valeurs);

   disp('- coefficients des pas du gradient normal');
   valeurs = [' alpha  = '+string(alfan)  ; ...
              ' theta  = '+string(thetan) ; ...
              ' lambda = '+string(lamdan)];
   disp(valeurs);

   disp('- coefficients des pas du gradient moyenne');
   valeurs = [' alpha  = '+string(alfam)  ; ...
              ' theta  = '+string(thetam) ; ...
              ' lambda = '+string(lamdam)];
   disp(valeurs);

/////////////////////////////
// S.O.W.G - Decembre 2007 //
/////////////////////////////
